#include <windows.h>
#include "3d.h"

LPCSTR szWindowClass = "SAMPLE_CLASS";
LPCSTR szWindowTitle = "3DeXg";

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    HDC hdc;
    RECT clearrect;
    camera_t camera;

    switch (message) {
		case WM_CREATE:
			SetTimer(hWnd,0,20,NULL);
			camera.x=0;
			camera.y=0;
			camera.z=0;
			camera.cx=0;
			camera.cy=0;
			camera.cz=0;
			camera.genkai=320;
			camera.genkaiangle=150;
			camera.centerx=320;
			camera.centery=240;
			clearrect.top=0;
			clearrect.left=0;
			clearrect.right=640;
			clearrect.bottom=480;
			break;
	    case WM_COMMAND:
    	    switch (LOWORD(wParam)) {
        		default:
            		return DefWindowProc(hWnd, message, wParam, lParam);
			}
        	break;
	    case WM_PAINT:
    	    hdc = BeginPaint(hWnd, &ps);
    	    FillRect(hdc,&clearrect,GetStockObject(WHITE_BRUSH));
    	    
    	    draw3dline(hdc,0,300,0,0,300,100,&camera);
    	    draw3dline(hdc,0,300,100,100,300,100,&camera);
    	    draw3dline(hdc,100,300,100,100,300,0,&camera);
    	    draw3dline(hdc,100,300,0,0,300,0,&camera);
    	    
    	    draw3dline(hdc,0,300,0,0,400,0,&camera);
    	    draw3dline(hdc,0,300,100,0,400,100,&camera);
    	    draw3dline(hdc,100,300,100,100,400,100,&camera);
    	    draw3dline(hdc,100,300,0,100,400,0,&camera);
    	    
    	    draw3dline(hdc,0,400,0,0,400,100,&camera);
    	    draw3dline(hdc,0,400,100,100,400,100,&camera);
    	    draw3dline(hdc,100,400,100,100,400,0,&camera);
    	    draw3dline(hdc,100,400,0,0,400,0,&camera);
    	    
        	EndPaint(hWnd, &ps);
        	break;
        case WM_TIMER:
			if(GetAsyncKeyState(VK_SHIFT) & 0x8000) {
				if(GetAsyncKeyState(VK_LEFT) & 0x8000)
					camera.cx-=dec2rad(1);
				if(GetAsyncKeyState(VK_UP) & 0x8000)
					camera.cy+=dec2rad(1);
				if(GetAsyncKeyState(VK_RIGHT) & 0x8000)
					camera.cx+=dec2rad(1);
				if(GetAsyncKeyState(VK_DOWN) & 0x8000)
					camera.cy-=dec2rad(1);
			} else {
				if(GetAsyncKeyState(VK_LEFT) & 0x8000)
					camera.x-=5;
				if(GetAsyncKeyState(VK_UP) & 0x8000)
					camera.z+=5;
				if(GetAsyncKeyState(VK_RIGHT) & 0x8000)
					camera.x+=5;
				if(GetAsyncKeyState(VK_DOWN) & 0x8000)
					camera.z-=5;
			}
			InvalidateRect(hWnd,NULL,1);
			break;
    	case WM_DESTROY:
			KillTimer(hWnd,0);
        	PostQuitMessage(0);
        	break;
    	default:
        	return DefWindowProc(hWnd, message, wParam, lParam);
   	}

    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    MSG msg;
    WNDCLASSEX wcex;
    HWND hWnd;

    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style          = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = hInstance;
    wcex.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
    wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = NULL;
    wcex.lpszClassName  = szWindowClass;
    wcex.hIconSm        = NULL;

    RegisterClassEx(&wcex);

    hWnd = CreateWindow(szWindowClass,
        szWindowTitle, WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
        NULL, NULL, hInstance, NULL);

    if (!hWnd)
        return FALSE;

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}
